//+------------------------------------------------------------------+
//|                                                      Program.mqh |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#include <EasyAndFastGUI\Controls\WndEvents.mqh>
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
class CProgram : public CWndEvents
  {
private:
   //--- 
   CWindow           m_window;
   //---      
   CMenuBar          m_menubar;
   CContextMenu      m_mb_contextmenu1;
   CContextMenu      m_mb_contextmenu2;
   CContextMenu      m_mb_contextmenu3;
   CContextMenu      m_mb_contextmenu4;
   //---    1    
   CMenuItem         m_menu_item1;
   CContextMenu      m_mi1_contextmenu1;
   CContextMenu      m_mi1_contextmenu2;
   //---    2    
   CMenuItem         m_menu_item2;
   CContextMenu      m_mi2_contextmenu1;
   //---    3    
   CMenuItem         m_menu_item3;
   CContextMenu      m_mi3_contextmenu1;
   //---    4    
   CMenuItem         m_menu_item4;
   CContextMenu      m_mi4_contextmenu1;
   //---    5    
   CMenuItem         m_menu_item5;
   CContextMenu      m_mi5_contextmenu1;
   //---  
   CSeparateLine     m_sep_line;
public:
                     CProgram(void);
                    ~CProgram(void);
   //--- /
   void              OnInitEvent(void);
   void              OnDeinitEvent(const int reason);
   //--- 
   void              OnTimerEvent(void);
   //---
protected:
   //---   
   virtual void      OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam);
   //---
public:
   //---   
   bool              CreateTradePanel(void);
   //---
private:
   bool              CreateWindow(const string text);
   //---
#define MENUBAR_GAP_X    (1)
#define MENUBAR_GAP_Y    (20)
   bool              CreateMenuBar(void);
   bool              CreateMBContextMenu1(void);
   bool              CreateMBContextMenu2(void);
   bool              CreateMBContextMenu3(void);
   bool              CreateMBContextMenu4(void);
   //---
#define MENU_ITEM1_GAP_X (6)
#define MENU_ITEM1_GAP_Y (45)
   bool              CreateMenuItem1(const string item_text);
   bool              CreateMI1ContextMenu1(void);
   bool              CreateMI1ContextMenu2(void);
   //---
#define MENU_ITEM2_GAP_X (6)
#define MENU_ITEM2_GAP_Y (70)
   bool              CreateMenuItem2(const string item_text);
   bool              CreateMI2ContextMenu1(void);
   //---
#define SEP_LINE_GAP_X   (6)
#define SEP_LINE_GAP_Y   (100)
   bool              CreateSepLine(void);
   //---
#define MENU_ITEM3_GAP_X (6)
#define MENU_ITEM3_GAP_Y (110)
   bool              CreateMenuItem3(const string item_text);
   bool              CreateMI3ContextMenu1(void);
   //---
#define MENU_ITEM4_GAP_X (6)
#define MENU_ITEM4_GAP_Y (135)
   bool              CreateMenuItem4(const string item_text);
   bool              CreateMI4ContextMenu1(void);
   //---
#define MENU_ITEM5_GAP_X (6)
#define MENU_ITEM5_GAP_Y (160)
   bool              CreateMenuItem5(const string item_text);
   bool              CreateMI5ContextMenu1(void);
  };
//+------------------------------------------------------------------+
//| Constructor                                                      |
//+------------------------------------------------------------------+
CProgram::CProgram(void)
  {
  }
//+------------------------------------------------------------------+
//| Destructor                                                       |
//+------------------------------------------------------------------+
CProgram::~CProgram(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void CProgram::OnInitEvent(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void CProgram::OnDeinitEvent(const int reason)
  {
//---  
   CWndEvents::Destroy();
  }
//+------------------------------------------------------------------+
//|                                                            |
//+------------------------------------------------------------------+
void CProgram::OnTimerEvent(void)
  {
   CWndEvents::OnTimerEvent();
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void CProgram::OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   if(id==CHARTEVENT_CUSTOM+ON_CLICK_CONTEXTMENU_ITEM)
     {
      ::Print(__FUNCTION__," > id: ",id,"; lparam: ",lparam,"; dparam: ",dparam,"; sparam: ",sparam);
     }
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool CProgram::CreateTradePanel(void)
  {
//---     
   if(!CreateWindow("EXPERT PANEL"))
      return(false);
//---   :
//     
   if(!CreateMenuBar())
      return(false);
//---  
   if(!CreateMBContextMenu1())
      return(false);
   if(!CreateMBContextMenu2())
      return(false);
   if(!CreateMBContextMenu3())
      return(false);
   if(!CreateMBContextMenu4())
      return(false);
//---   1
   if(!CreateMenuItem1("Menu item 1"))
      return(false);
//---  
   if(!CreateMI1ContextMenu1())
      return(false);
   if(!CreateMI1ContextMenu2())
      return(false);
//---   2
   if(!CreateMenuItem2("Menu item 2"))
      return(false);
//---  
   if(!CreateMI2ContextMenu1())
      return(false);
//---  
   if(!CreateSepLine())
      return(false);
//---   3
   if(!CreateMenuItem3("Menu item 3"))
      return(false);
//---  
   if(!CreateMI3ContextMenu1())
      return(false);
//---   4
   if(!CreateMenuItem4("Menu item 4"))
      return(false);
//---  
   if(!CreateMI4ContextMenu1())
      return(false);
//---   5
   if(!CreateMenuItem5("Menu item 5"))
      return(false);
//---  
   if(!CreateMI5ContextMenu1())
      return(false);
//---  
   m_chart.Redraw();
   return(true);
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool CProgram::CreateWindow(const string caption_text)
  {
//---      
   CWndContainer::AddWindow(m_window);
//--- 
   int x=1;
   int y=20;
//--- 
   m_window.Movable(true);
   m_window.XSize(205);
   m_window.YSize(190);
   m_window.CaptionBgColor(clrCornflowerBlue);
   m_window.CaptionBgColorHover(C'150,190,240');
//---  
   if(!m_window.CreateWindow(m_chart_id,m_subwin,caption_text,x,y))
      return(false);
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
bool CProgram::CreateMenuBar(void)
  {
//---     
#define MENUBAR_TOTAL 3
//---    
   m_menubar.WindowPointer(m_window);
//--- 
   int x=m_window.X()+MENUBAR_GAP_X;
   int y=m_window.Y()+MENUBAR_GAP_Y;
//---     
   int    width[MENUBAR_TOTAL] ={50,55,53};
   string text[MENUBAR_TOTAL]  ={"File","View","Help"};
//---     
   for(int i=0; i<MENUBAR_TOTAL; i++)
      m_menubar.AddItem(width[i],text[i]);
//---   
   if(!m_menubar.CreateMenuBar(m_chart_id,m_subwin,x,y))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_menubar);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart_colorless.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\safe.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\safe_colorless.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\pie_chart.bmp"
#resource "\\Images\\EasyAndFastGUI\\Icons\\bmp16\\pie_chart_colorless.bmp"
#resource "\\Images\\EasyAndFastGUI\\Controls\\CheckBoxOn_min_black.bmp"
//---
bool CProgram::CreateMBContextMenu1(void)
  {
//---     
#define CONTEXTMENU_ITEMS1 3
//---    
   m_mb_contextmenu1.WindowPointer(m_window);
//---     
   m_mb_contextmenu1.PrevNodePointer(m_menubar.ItemPointerByIndex(0));
//---       
   m_menubar.AddContextMenuPointer(0,m_mb_contextmenu1);
//---   
   string items_text[CONTEXTMENU_ITEMS1]=
     {
      "ContextMenu 1 Item 1",
      "ContextMenu 1 Item 2",
      "ContextMenu 1 Item 3..."
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS1]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart.bmp"
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS1]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart_colorless.bmp"
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_SIMPLE
     };
//---    
   m_mb_contextmenu1.FixSide(FIX_BOTTOM);
   m_mb_contextmenu1.XSize(160);
   m_mb_contextmenu1.AreaBackColor(C'240,240,240');
   m_mb_contextmenu1.AreaBorderColor(clrSilver);
   m_mb_contextmenu1.ItemBackColorHover(C'240,240,240');
   m_mb_contextmenu1.ItemBackColorHoverOff(clrLightGray);
   m_mb_contextmenu1.ItemBorderColor(C'240,240,240');
   m_mb_contextmenu1.LabelColor(clrBlack);
   m_mb_contextmenu1.LabelColorHover(clrWhite);
   m_mb_contextmenu1.SeparateLineDarkColor(C'160,160,160');
   m_mb_contextmenu1.SeparateLineLightColor(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS1; i++)
      m_mb_contextmenu1.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mb_contextmenu1.AddSeparateLine(1);
//---   
   m_mb_contextmenu1.ItemPointerByIndex(1).ItemState(false);
//---   
   if(!m_mb_contextmenu1.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mb_contextmenu1);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMBContextMenu2(void)
  {
//---     
#define CONTEXTMENU_ITEMS2 3
//---    
   m_mb_contextmenu2.WindowPointer(m_window);
//---     
   m_mb_contextmenu2.PrevNodePointer(m_menubar.ItemPointerByIndex(1));
//---       
   m_menubar.AddContextMenuPointer(1,m_mb_contextmenu2);
//---   
   string items_text[CONTEXTMENU_ITEMS2]=
     {
      "ContextMenu 2 Item 1",
      "ContextMenu 2 Item 2",
      "ContextMenu 2 Item 3"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS2]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      ""
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS2]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Controls\\CheckBoxOn_min_black.bmp"
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS2]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_CHECKBOX
     };
//---    
   m_mb_contextmenu2.FixSide(FIX_BOTTOM);
   m_mb_contextmenu2.XSize(160);
   m_mb_contextmenu2.AreaBackColor(C'240,240,240');
   m_mb_contextmenu2.AreaBorderColor(clrSilver);
   m_mb_contextmenu2.ItemBackColorHover(C'240,240,240');
   m_mb_contextmenu2.ItemBackColorHoverOff(clrLightGray);
   m_mb_contextmenu2.ItemBorderColor(C'240,240,240');
   m_mb_contextmenu2.LabelColor(clrBlack);
   m_mb_contextmenu2.LabelColorHover(clrWhite);
   m_mb_contextmenu2.SeparateLineDarkColor(C'160,160,160');
   m_mb_contextmenu2.SeparateLineLightColor(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS2; i++)
      m_mb_contextmenu2.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mb_contextmenu2.AddSeparateLine(1);
//---   
   if(!m_mb_contextmenu2.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mb_contextmenu2);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
#resource "\\Images\\EasyAndFastGUI\\Controls\\RightTransp_black.bmp"
//---
bool CProgram::CreateMBContextMenu3(void)
  {
//---     
#define CONTEXTMENU_ITEMS3 5
//---    
   m_mb_contextmenu3.WindowPointer(m_window);
//---     
   m_mb_contextmenu3.PrevNodePointer(m_menubar.ItemPointerByIndex(2));
//---       
   m_menubar.AddContextMenuPointer(2,m_mb_contextmenu3);
//---   
   string items_text[CONTEXTMENU_ITEMS3]=
     {
      "ContextMenu 3 Item 1",
      "ContextMenu 3 Item 2",
      "ContextMenu 3 Item 3...",
      "ContextMenu 3 Item 4",
      "ContextMenu 3 Item 5"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS3]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart.bmp",
      "",""
     };
//---      
   string items_bmp_off[CONTEXTMENU_ITEMS3]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Controls\\CheckBoxOn_min_black.bmp",
      "Images\\EasyAndFastGUI\\Controls\\CheckBoxOn_min_black.bmp"
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS3]=
     {
      MI_SIMPLE,
      MI_HAS_CONTEXT_MENU,
      MI_SIMPLE,
      MI_CHECKBOX,
      MI_CHECKBOX
     };
//---    
   m_mb_contextmenu3.FixSide(FIX_BOTTOM);
   m_mb_contextmenu3.XSize(160);
   m_mb_contextmenu3.AreaBackColor(C'240,240,240');
   m_mb_contextmenu3.AreaBorderColor(clrSilver);
   m_mb_contextmenu3.ItemBackColorHover(C'240,240,240');
   m_mb_contextmenu3.ItemBackColorHoverOff(clrLightGray);
   m_mb_contextmenu3.ItemBorderColor(C'240,240,240');
   m_mb_contextmenu3.LabelColor(clrBlack);
   m_mb_contextmenu3.LabelColorHover(clrWhite);
   m_mb_contextmenu3.SeparateLineDarkColor(C'160,160,160');
   m_mb_contextmenu3.SeparateLineLightColor(clrWhite);
   m_mb_contextmenu3.RightArrowFileOff("Images\\EasyAndFastGUI\\Controls\\RightTransp_black.bmp");
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS3; i++)
      m_mb_contextmenu3.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mb_contextmenu3.AddSeparateLine(2);
//---   
   if(!m_mb_contextmenu3.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mb_contextmenu3);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMBContextMenu4(void)
  {
//---     
#define CONTEXTMENU_ITEMS4 3
//---    
   m_mb_contextmenu4.WindowPointer(m_window);
//---     
   m_mb_contextmenu4.PrevNodePointer(m_mb_contextmenu3.ItemPointerByIndex(1));
//---   
   string items_text[CONTEXTMENU_ITEMS4]=
     {
      "ContextMenu 4 Item 1",
      "ContextMenu 4 Item 2",
      "ContextMenu 4 Item 3"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS4]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      ""
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS4]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Controls\\CheckBoxOn_min_black.bmp"
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS4]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_CHECKBOX
     };
//---    
   m_mb_contextmenu4.XSize(160);
   m_mb_contextmenu4.AreaBackColor(C'240,240,240');
   m_mb_contextmenu4.AreaBorderColor(clrSilver);
   m_mb_contextmenu4.ItemBackColorHover(C'240,240,240');
   m_mb_contextmenu4.ItemBackColorHoverOff(clrLightGray);
   m_mb_contextmenu4.ItemBorderColor(C'240,240,240');
   m_mb_contextmenu4.LabelColor(clrBlack);
   m_mb_contextmenu4.LabelColorHover(clrWhite);
   m_mb_contextmenu4.SeparateLineDarkColor(C'160,160,160');
   m_mb_contextmenu4.SeparateLineLightColor(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS4; i++)
      m_mb_contextmenu4.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mb_contextmenu4.AddSeparateLine(1);
//---   
   if(!m_mb_contextmenu4.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mb_contextmenu4);
   return(true);
  }
//+------------------------------------------------------------------+
//|    1                                             |
//+------------------------------------------------------------------+
bool CProgram::CreateMenuItem1(string item_text)
  {
//---    
   m_menu_item1.WindowPointer(m_window);
//---   
   int x=m_window.X()+MENU_ITEM1_GAP_X;
   int y=m_window.Y()+MENU_ITEM1_GAP_Y;
//---    
   m_menu_item1.XSize(193);
   m_menu_item1.YSize(24);
   m_menu_item1.TypeMenuItem(MI_HAS_CONTEXT_MENU);
   m_menu_item1.IconFileOn("Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart.bmp");
   m_menu_item1.IconFileOff("Images\\EasyAndFastGUI\\Icons\\bmp16\\bar_chart_colorless.bmp");
   m_menu_item1.LabelColor(clrWhite);
   m_menu_item1.LabelColorHover(clrWhite);
//---   
   if(!m_menu_item1.CreateMenuItem(m_chart_id,m_subwin,0,item_text,x,y))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_menu_item1);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMI1ContextMenu1(void)
  {
//---     
#define CONTEXTMENU_ITEMS5 5
//---    
   m_mi1_contextmenu1.WindowPointer(m_window);
//---     
   m_mi1_contextmenu1.PrevNodePointer(m_menu_item1);
//---   
   string items_text[CONTEXTMENU_ITEMS5]=
     {
      "ContextMenu 5 Item 1",
      "ContextMenu 5 Item 2",
      "ContextMenu 5 Item 3",
      "ContextMenu 5 Item 4",
      "ContextMenu 5 Item 5"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS5]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe.bmp",
      "",""
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS5]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe_colorless.bmp",
      "",""
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS5]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_HAS_CONTEXT_MENU,
      MI_CHECKBOX,
      MI_CHECKBOX
     };
//---    
   m_mi1_contextmenu1.XSize(160);
   m_mi1_contextmenu1.ItemBackColorHoverOff(C'70,80,90');
   m_mi1_contextmenu1.LabelColor(clrWhite);
   m_mi1_contextmenu1.LabelColorHover(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS5; i++)
      m_mi1_contextmenu1.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mi1_contextmenu1.AddSeparateLine(1);
//---   
   m_mi1_contextmenu1.ItemPointerByIndex(1).ItemState(false);
//---   
   m_mi1_contextmenu1.CheckBoxStateByIndex(3,false);
//---   
   if(!m_mi1_contextmenu1.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mi1_contextmenu1);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMI1ContextMenu2(void)
  {
//---     
#define CONTEXTMENU_ITEMS6 6
//---    
   m_mi1_contextmenu2.WindowPointer(m_window);
//---     
   m_mi1_contextmenu2.PrevNodePointer(m_mi1_contextmenu1.ItemPointerByIndex(2));
//---   
   string items_text[CONTEXTMENU_ITEMS6]=
     {
      "ContextMenu 6 Item 1",
      "ContextMenu 6 Item 2",
      "ContextMenu 6 Item 3",
      "ContextMenu 6 Item 4",
      "ContextMenu 6 Item 5",
      "ContextMenu 6 Item 6"
     };
//---    
   m_mi1_contextmenu2.XSize(160);
   m_mi1_contextmenu2.LabelColor(clrWhite);
   m_mi1_contextmenu2.LabelColorHover(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS6; i++)
      m_mi1_contextmenu2.AddItem(items_text[i],"","",MI_RADIOBUTTON);
//---     
   m_mi1_contextmenu2.AddSeparateLine(2);
//---       (1)
   for(int i=3; i<6; i++)
      m_mi1_contextmenu2.RadioItemIdByIndex(i,1);
//---  -   
   m_mi1_contextmenu2.SelectedRadioItem(1,0);
   m_mi1_contextmenu2.SelectedRadioItem(2,1);
//---   
   if(!m_mi1_contextmenu2.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mi1_contextmenu2);
   return(true);
  }
//+------------------------------------------------------------------+
//|    2                                             |
//+------------------------------------------------------------------+
bool CProgram::CreateMenuItem2(string item_text)
  {
//---    
   m_menu_item2.WindowPointer(m_window);
//---   
   int x=m_window.X()+MENU_ITEM2_GAP_X;
   int y=m_window.Y()+MENU_ITEM2_GAP_Y;
//---    
   m_menu_item2.XSize(193);
   m_menu_item2.YSize(24);
   m_menu_item2.TypeMenuItem(MI_HAS_CONTEXT_MENU);
   m_menu_item2.IconFileOn("Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp");
   m_menu_item2.IconFileOff("Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp");
   m_menu_item2.LabelColor(clrWhite);
   m_menu_item2.LabelColorHover(clrWhite);
//---   
   if(!m_menu_item2.CreateMenuItem(m_chart_id,m_subwin,0,item_text,x,y))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_menu_item2);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMI2ContextMenu1(void)
  {
//---     
#define CONTEXTMENU_ITEMS7 5
//---    
   m_mi2_contextmenu1.WindowPointer(m_window);
//---     
   m_mi2_contextmenu1.PrevNodePointer(m_menu_item2);
//---   
   string items_text[CONTEXTMENU_ITEMS5]=
     {
      "ContextMenu 7 Item 1",
      "ContextMenu 7 Item 2",
      "ContextMenu 7 Item 3",
      "ContextMenu 7 Item 4",
      "ContextMenu 7 Item 5"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS7]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe.bmp",
      "",""
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS7]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe_colorless.bmp",
      "",""
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS7]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_SIMPLE,
      MI_CHECKBOX,
      MI_CHECKBOX
     };
//---    
   m_mi2_contextmenu1.XSize(160);
   m_mi2_contextmenu1.ItemBackColorHoverOff(C'70,80,90');
   m_mi2_contextmenu1.LabelColor(clrWhite);
   m_mi2_contextmenu1.LabelColorHover(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS7; i++)
      m_mi2_contextmenu1.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mi2_contextmenu1.AddSeparateLine(1);
//---   
   if(!m_mi2_contextmenu1.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mi2_contextmenu1);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
bool CProgram::CreateSepLine(void)
  {
//---    
   m_sep_line.WindowPointer(m_window);
//---   
   int x=m_window.X()+SEP_LINE_GAP_X;
   int y=m_window.Y()+SEP_LINE_GAP_Y;
//---  
   if(!m_sep_line.CreateSeparateLine(m_chart_id,m_subwin,0,x,y,193,2))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_sep_line);
   return(true);
  }
//+------------------------------------------------------------------+
//|    3                                             |
//+------------------------------------------------------------------+
bool CProgram::CreateMenuItem3(string item_text)
  {
//---    
   m_menu_item3.WindowPointer(m_window);
//---   
   int x=m_window.X()+MENU_ITEM3_GAP_X;
   int y=m_window.Y()+MENU_ITEM3_GAP_Y;
//---    
   m_menu_item3.XSize(193);
   m_menu_item3.YSize(24);
   m_menu_item3.TypeMenuItem(MI_HAS_CONTEXT_MENU);
   m_menu_item3.IconFileOn("Images\\EasyAndFastGUI\\Icons\\bmp16\\safe.bmp");
   m_menu_item3.IconFileOff("Images\\EasyAndFastGUI\\Icons\\bmp16\\safe_colorless.bmp");
   m_menu_item3.LabelColor(clrWhite);
   m_menu_item3.LabelColorHover(clrWhite);
//---   
   if(!m_menu_item3.CreateMenuItem(m_chart_id,m_subwin,0,item_text,x,y))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_menu_item3);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMI3ContextMenu1(void)
  {
//---     
#define CONTEXTMENU_ITEMS8 5
//---    
   m_mi3_contextmenu1.WindowPointer(m_window);
//---     
   m_mi3_contextmenu1.PrevNodePointer(m_menu_item3);
//---   
   string items_text[CONTEXTMENU_ITEMS8]=
     {
      "ContextMenu 8 Item 1",
      "ContextMenu 8 Item 2",
      "ContextMenu 8 Item 3",
      "ContextMenu 8 Item 4",
      "ContextMenu 8 Item 5"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS8]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe.bmp",
      "",""
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS8]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe_colorless.bmp",
      "",""
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS8]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_SIMPLE,
      MI_CHECKBOX,
      MI_CHECKBOX
     };
//---    
   m_mi3_contextmenu1.XSize(160);
   m_mi3_contextmenu1.ItemBackColorHoverOff(C'70,80,90');
   m_mi3_contextmenu1.LabelColor(clrWhite);
   m_mi3_contextmenu1.LabelColorHover(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS8; i++)
      m_mi3_contextmenu1.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mi3_contextmenu1.AddSeparateLine(1);
//---   
   if(!m_mi3_contextmenu1.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mi3_contextmenu1);
   return(true);
  }
//+------------------------------------------------------------------+
//|    4                                             |
//+------------------------------------------------------------------+
bool CProgram::CreateMenuItem4(string item_text)
  {
//---    
   m_menu_item4.WindowPointer(m_window);
//---   
   int x=m_window.X()+MENU_ITEM4_GAP_X;
   int y=m_window.Y()+MENU_ITEM4_GAP_Y;
//---    
   m_menu_item4.XSize(193);
   m_menu_item4.YSize(24);
   m_menu_item4.TypeMenuItem(MI_HAS_CONTEXT_MENU);
   m_menu_item4.IconFileOn("Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp");
   m_menu_item4.IconFileOff("Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp");
   m_menu_item4.LabelColor(clrWhite);
   m_menu_item4.LabelColorHover(clrWhite);
//---   
   if(!m_menu_item4.CreateMenuItem(m_chart_id,m_subwin,0,item_text,x,y))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_menu_item4);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMI4ContextMenu1(void)
  {
//---     
#define CONTEXTMENU_ITEMS9 5
//---    
   m_mi4_contextmenu1.WindowPointer(m_window);
//---     
   m_mi4_contextmenu1.PrevNodePointer(m_menu_item4);
//---   
   string items_text[CONTEXTMENU_ITEMS9]=
     {
      "ContextMenu 9 Item 1",
      "ContextMenu 9 Item 2",
      "ContextMenu 9 Item 3",
      "ContextMenu 9 Item 4",
      "ContextMenu 9 Item 5"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS9]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe.bmp",
      "",""
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS9]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe_colorless.bmp",
      "",""
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS9]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_SIMPLE,
      MI_CHECKBOX,
      MI_CHECKBOX
     };
//---    
   m_mi4_contextmenu1.XSize(160);
   m_mi4_contextmenu1.ItemBackColorHoverOff(C'70,80,90');
   m_mi4_contextmenu1.LabelColor(clrWhite);
   m_mi4_contextmenu1.LabelColorHover(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS9; i++)
      m_mi4_contextmenu1.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mi4_contextmenu1.AddSeparateLine(1);
//---   
   if(!m_mi4_contextmenu1.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mi4_contextmenu1);
   return(true);
  }
//+------------------------------------------------------------------+
//|    5                                             |
//+------------------------------------------------------------------+
bool CProgram::CreateMenuItem5(string item_text)
  {
//---    
   m_menu_item5.WindowPointer(m_window);
//---   
   int x=m_window.X()+MENU_ITEM5_GAP_X;
   int y=m_window.Y()+MENU_ITEM5_GAP_Y;
//---    
   m_menu_item5.XSize(193);
   m_menu_item5.YSize(24);
   m_menu_item5.TypeMenuItem(MI_HAS_CONTEXT_MENU);
   m_menu_item5.IconFileOn("Images\\EasyAndFastGUI\\Icons\\bmp16\\pie_chart.bmp");
   m_menu_item5.IconFileOff("Images\\EasyAndFastGUI\\Icons\\bmp16\\pie_chart_colorless.bmp");
   m_menu_item5.LabelColor(clrWhite);
   m_menu_item5.LabelColorHover(clrWhite);
//---   
   if(!m_menu_item5.CreateMenuItem(m_chart_id,m_subwin,0,item_text,x,y))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_menu_item5);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool CProgram::CreateMI5ContextMenu1(void)
  {
//---     
#define CONTEXTMENU_ITEMS10 5
//---    
   m_mi5_contextmenu1.WindowPointer(m_window);
//---     
   m_mi5_contextmenu1.PrevNodePointer(m_menu_item5);
//---   
   string items_text[CONTEXTMENU_ITEMS10]=
     {
      "ContextMenu 10 Item 1",
      "ContextMenu 10 Item 2",
      "ContextMenu 10 Item 3",
      "ContextMenu 10 Item 4",
      "ContextMenu 10 Item 5"
     };
//---     
   string items_bmp_on[CONTEXTMENU_ITEMS10]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe.bmp",
      "",""
     };
//---     
   string items_bmp_off[CONTEXTMENU_ITEMS10]=
     {
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\coins_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\line_chart_colorless.bmp",
      "Images\\EasyAndFastGUI\\Icons\\bmp16\\safe_colorless.bmp",
      "",""
     };
//---   
   ENUM_TYPE_MENU_ITEM items_type[CONTEXTMENU_ITEMS10]=
     {
      MI_SIMPLE,
      MI_SIMPLE,
      MI_SIMPLE,
      MI_CHECKBOX,
      MI_CHECKBOX
     };
//---    
   m_mi5_contextmenu1.XSize(160);
   m_mi5_contextmenu1.ItemBackColorHoverOff(C'70,80,90');
   m_mi5_contextmenu1.LabelColor(clrWhite);
   m_mi5_contextmenu1.LabelColorHover(clrWhite);
//---     
   for(int i=0; i<CONTEXTMENU_ITEMS10; i++)
      m_mi5_contextmenu1.AddItem(items_text[i],items_bmp_on[i],items_bmp_off[i],items_type[i]);
//---     
   m_mi5_contextmenu1.AddSeparateLine(1);
//---   
   if(!m_mi5_contextmenu1.CreateContextMenu(m_chart_id,m_subwin))
      return(false);
//---      
   CWndContainer::AddToElementsArray(0,m_mi5_contextmenu1);
   return(true);
  }
//+------------------------------------------------------------------+
